package main.java.SignalPlanRecommender;

import java.util.ArrayList;

import net.sourceforge.chart2d.LegendProperties;

public class SignalPlan {
	Integer id, totalYellowTime, totalCycleTime, totalPhaseTime;
	ArrayList<Phase> cycle;
	int[] yellowTimes;
	
	public SignalPlan(int[] lengthOfPhases, int[] yellowTimes) {
		cycle = new ArrayList<Phase>();
		for(int i=0; i<lengthOfPhases.length;i++) {
			cycle.add(new Phase(lengthOfPhases[i]));
			cycle.add(new Phase(yellowTimes[i]));
		}
		this.yellowTimes = yellowTimes;
		refreshCycleInformation();
	}
	
	public void scaleToCycleOfGivenLength(int cycleLength) {
		double totalPhaseTimeShouldBe = cycleLength - totalYellowTime;
		double scaleCoefficient = totalPhaseTimeShouldBe/totalPhaseTime;
		System.out.println("SCALING COEFFICIENT = " + scaleCoefficient);
		for (int i = 0; i< cycle.size(); i+=2) {
			System.out.print("Changed " + cycle.get(i).getLength() + "to " );
			cycle.get(i).setLength((int)(cycle.get(i).getLength()*scaleCoefficient));
			System.out.println(cycle.get(i).getLength());
		}
		//If the cycle time is not exactly cycleLength, then the difference is added or subtracted from the first phase.

		
		//Ensure that phase 2 and 3 last for 4 seconds or more
		if (this.cycle.get(1).getLength() < 4) {
			this.cycle.get(1).setLength(4);
		}

		if (this.cycle.get(2).getLength() < 4) {
			this.cycle.get(2).setLength(4);
		}

		refreshCycleInformation();		
		int difference = cycleLength - this.totalCycleTime;
		this.cycle.get(0).setLength(this.cycle.get(0).getLength()+difference);

		refreshCycleInformation();
	}
	
	public void refreshCycleInformation() {
		totalCycleTime = getTotalCycleTime();
		totalYellowTime = getTotalyellowTime(yellowTimes);
		totalPhaseTime = totalCycleTime - totalYellowTime;
	}
	
	private int getTotalyellowTime(int[] yellowTimes) {
		int totalYellowTime = 0;
		for (int yellowTime : yellowTimes) {
			totalYellowTime += yellowTime;
		}
		return totalYellowTime;
	}
	
	
	private int getTotalCycleTime() {
		int totalCycleTime = 0;
		for (Phase phase : cycle) {
			totalCycleTime += phase.getLength();
		}
		return totalCycleTime;
	}
	
	@Override
	public String toString() {
		String s = "";
		for (Phase p : cycle)
			s = s.concat(p.toString());

		return " Cycle: " + s;
	}
	
	
	public Integer getCycleLength() {
		//TODO
		return 1;
	}
	
	public ArrayList<Phase> getCycle() {
		return cycle;
	}
	public void setCycle(ArrayList<Phase> cycle) {
		this.cycle = cycle;
	}
	
	public Integer getId() {
		return id;
	}


	public void setId(Integer id) {
		this.id = id;
	}
	
}
