package main.java.adapter;

import java.sql.Date;

import jcolibri.cbrcore.CaseComponent;
import main.java.SignalPlanRecommender.Phase;
import main.java.SignalPlanRecommender.ProblemDescription;
import main.java.SignalPlanRecommender.ProblemDescription.DayOfWeek;
import main.java.SignalPlanRecommender.ProblemDescription.Event;
import main.java.SignalPlanRecommender.ProblemDescription.Friction;
import main.java.SignalPlanRecommender.ProblemDescription.Season;
import main.java.SignalPlanRecommender.ProblemDescription.Temperature;
import main.java.SignalPlanRecommender.ProblemDescription.TimeOfDay;
import main.java.SignalPlanRecommender.ProblemDescription.WeatherSituation;
import main.java.SignalPlanRecommender.ProblemSolution;
import main.java.SignalPlanRecommender.SignalPlan;
import main.java.SignalPlanRecommender.TrafficSituation;

public class AimsunCaseAdapter implements CaseAdapter{
	ProblemDescription[] problemDescriptions;
	ProblemDescription problemDescription;
	TrafficSituation ts;
	

	@Override
	public ProblemDescription adaptFromExternalSystem(String receivedData) {
		String[] features = receivedData.replaceAll("\\s","").split(",");
		System.out.println("Features" + features[1]);
		problemDescription = new ProblemDescription();
			
		problemDescription.setSeason(Season.valueOf(features[0]));
		problemDescription.setDayOfWeek(DayOfWeek.valueOf(features[1]));
		problemDescription.setTimeOfDay(TimeOfDay.valueOf(features[2]));
		problemDescription.setWeatherSituation(WeatherSituation.valueOf(features[3]));
		problemDescription.setTemperature(Temperature.valueOf(features[4]));
		problemDescription.setFriction(Friction.valueOf(features[5]));
		problemDescription.setEvent(Event.valueOf(features[6]));
			
			
//			ts.setFlowNS(Integer.valueOf(trafficFlow[0]));
//			ts.setFlowEW(Integer.valueOf(trafficFlow[1]));
//			ts.setFlowSN(Integer.valueOf(trafficFlow[2]));
//			ts.setFlowWE(Integer.valueOf(trafficFlow[3]));
//
//			problemDescription.setTrafficSituation(ts);

		return problemDescription;
	}
	


	@Override
//	public String adaptToExternalSystem(CaseComponent solution) {
//		ProblemSolution ps = (ProblemSolution)solution;
//		
//		String s = "";
////		Phase[] cycle = ps.getSignalPlan().getCycle());
//		for (Phase p : ps.getSignalPlan().getCycle()){
//			s = s.concat(p.getLength().toString()).concat(",3,");
//		}
//		s = s.substring(0, s.length()-1);
//
//		System.out.println("Solution "+ solution.toString());
//		return s;
//	}
	public String adaptToExternalSystem(SignalPlan sp) {
		String s = "";
		for (Phase p : sp.getCycle()){
			s = s.concat(p.getLength().toString()).concat(",");
		}
		s = s.substring(0, s.length()-1);

		System.out.println("Solution "+ s);
		return s;
	}
	
	public static void main(String[] args) {
//		String fromAimsunSystem = "1000,200,2,1-400,400,400,400";
		String fromAimsunSystem = "Fall,Monday,Morning,Precipitation,Medium,None";
		AimsunCaseAdapter aca = new AimsunCaseAdapter();
		ProblemDescription result = new ProblemDescription();
		result = aca.adaptFromExternalSystem(fromAimsunSystem);
		
		System.out.println("pd " + result.toString());
		
	}

}
