package main.java.genetic_algorithm;

import java.util.List;

import main.java.SignalPlanRecommender.SignalPlanRecommender;
import main.java.evaluate.CaseBaseEvaluator;

import org.uncommons.maths.binary.BitString;
import org.uncommons.watchmaker.framework.FitnessEvaluator;

public class BinaryFeatureWeightEvaluator implements FitnessEvaluator<BitString> {

	CaseBaseEvaluator caseBaseEvaluator;
	SignalPlanRecommender spr;
	
	public BinaryFeatureWeightEvaluator(CaseBaseEvaluator cbe) {
		caseBaseEvaluator = cbe;
		spr = caseBaseEvaluator.getSignalPlanRecommender();
	}

	public double getFitness(BitString candidate, List<? extends BitString> population) {
		caseBaseEvaluator.setWeights(makeWeightsFromBitString(candidate));
		return caseBaseEvaluator.getFitnessOfCaseBaseUsingLeaveOneOut();
	}
	
	
	public double[] makeWeightsFromBitString(BitString bitString) {
		double[] featureWeights = new double[7];
		int counter = 0;
		int numberOfBitsInAWeight =bitString.getLength()/featureWeights.length; 
		BitString tempBitString = new BitString(numberOfBitsInAWeight);
		for (int i=0; i<featureWeights.length;i++) {
			for (int j=0;j< numberOfBitsInAWeight;j++) {
				tempBitString.setBit(j, bitString.getBit(counter));
				counter ++;
			}
			featureWeights[i] = Double.parseDouble(tempBitString.toNumber().toString())/127;
		}
		
		return featureWeights;
	}
		
	public boolean isNatural()
	{
		return true;
	}
}
