package main.java.genetic_algorithm;

import java.util.List;

import jcolibri.cbrcore.Attribute;
import jcolibri.method.retrieve.NNretrieval.similarity.global.Average;
import jcolibri.method.retrieve.NNretrieval.similarity.local.Equal;
import jcolibri.method.retrieve.NNretrieval.similarity.local.Table;

import org.uncommons.watchmaker.framework.FitnessEvaluator;

import main.java.SignalPlanRecommender.ProblemDescription;
import main.java.SignalPlanRecommender.SignalPlanRecommender;
import main.java.evaluate.CaseBaseEvaluator;

public class FeatureWeightEvaluator implements FitnessEvaluator<double[]> {
	CaseBaseEvaluator caseBaseEvaluator;
	SignalPlanRecommender spr;
	
	public FeatureWeightEvaluator(CaseBaseEvaluator cbe) {
		caseBaseEvaluator = cbe;
		spr = caseBaseEvaluator.getSignalPlanRecommender();
	}

	public double getFitness(double[] candidate, List<? extends double[]> population) {
		caseBaseEvaluator.setWeights(candidate);
		return caseBaseEvaluator.getFitnessOfCaseBaseUsingLeaveOneOut();
	}
		
	public boolean isNatural()
	{
		return true;
	}

}
