package main.java.genetic_algorithm;

import java.util.LinkedList;
import java.util.List;
import java.util.Random;

import jcolibri.extensions.textual.IE.gate.gateinit.InitGate;


import main.java.evaluate.CaseBaseEvaluator;

import org.uncommons.watchmaker.framework.CandidateFactory;
import org.uncommons.watchmaker.framework.EvolutionEngine;
import org.uncommons.watchmaker.framework.EvolutionObserver;
import org.uncommons.watchmaker.framework.EvolutionaryOperator;
import org.uncommons.watchmaker.framework.FitnessEvaluator;
import org.uncommons.watchmaker.framework.GenerationalEvolutionEngine;
import org.uncommons.watchmaker.framework.PopulationData;
import org.uncommons.watchmaker.framework.SelectionStrategy;
import org.uncommons.watchmaker.framework.factories.ObjectArrayPermutationFactory;
import org.uncommons.watchmaker.framework.interactive.InteractiveSelection;
import org.uncommons.watchmaker.framework.operators.DoubleArrayCrossover;
import org.uncommons.watchmaker.framework.operators.EvolutionPipeline;
import org.uncommons.watchmaker.framework.operators.ListOrderMutation;
import org.uncommons.watchmaker.framework.operators.Replacement;
import org.uncommons.watchmaker.framework.selection.RouletteWheelSelection;
import org.uncommons.watchmaker.framework.selection.TournamentSelection;
import org.uncommons.watchmaker.framework.termination.TargetFitness;
import org.uncommons.maths.random.MersenneTwisterRNG;
import org.uncommons.maths.random.Probability;


public class FeatureWeighter {

	/**
	 * @param args
	 */
	static CaseBaseEvaluator cbe; 
	
	public static void main(String[] args) {
//		CandidateFactory<Double> factory = new FeatureWeightCandidateFactory(7);
		cbe = new CaseBaseEvaluator();
//		CandidateFactory<Double[]> factory = new ObjectArrayPermutationFactory<Double>(initweights);
		Random rng = new MersenneTwisterRNG();
		CandidateFactory<double[]> factory = new FeatureWeightCandidateFactory(7);
		List<EvolutionaryOperator<double[]>> operators = new LinkedList<EvolutionaryOperator<double[]>>();
		operators.add(new DoubleArrayCrossover());
//		operators.add(new Replacement<double[]>(factory, new Probability(0.2)));
		operators.add(new DoubleArrayMutation(new Probability(0.05)));
		EvolutionaryOperator<double[]> pipeline = new EvolutionPipeline<double[]>(operators);
		FitnessEvaluator<double[]> fitnessEvaluator = new FeatureWeightEvaluator(cbe);
		SelectionStrategy<double[]> selectionStrategy = new FeatureWeightRouletteWheelSelection<double[]>();
		

		EvolutionEngine<double[]> engine = new GenerationalEvolutionEngine<double[]>(
				factory, pipeline, fitnessEvaluator, selectionStrategy, rng);

		
		engine.addEvolutionObserver(new EvolutionObserver<double[]>() {
			public void populationUpdate(PopulationData<? extends double[]> data)
			{
				double[] bestCandidate = data.getBestCandidate();
				System.out.printf("Generation %d: %s, %s, %s, %s, %s, %s, %s Fitness: %s\n",
						data.getGenerationNumber(),
						bestCandidate[0],
						bestCandidate[1],
						bestCandidate[2],
						bestCandidate[3],
						bestCandidate[4],
						bestCandidate[5],
						bestCandidate[6],
						data.getBestCandidateFitness());
				cbe.setWeights(bestCandidate);
				System.out.println("FITNESS OF BEST " + cbe.getFitnessOfCaseBaseUsingLeaveOneOut());
			}
		});
		
		double[] result = engine.evolve(5,0, new TargetFitness(0.8, true));
		System.out.println(result);
		
	}

}
