package main.java.network;

import java.io.*;
import java.net.*;

public class TCPServer 
{
	String fromClient;
	String toClient;
	ServerSocket Server;
	Socket connected;
	BufferedReader inFromClient;
	PrintWriter outToClient;
	
	public TCPServer(int port) throws IOException {
		Server = new ServerSocket(port);
        System.out.println ("TCPServer Waiting for client on port 5000");
		connected = Server.accept();
        System.out.println( " THE CLIENT"+" "+
		connected.getInetAddress() +":"+connected.getPort()+" IS CONNECTED ");

        inFromClient = new BufferedReader(new InputStreamReader (connected.getInputStream()));
        outToClient = new PrintWriter(connected.getOutputStream(),true);
		outToClient.println("You are connected...");
	}
	
	public String receiveData() throws IOException {
		System.out.println("Trying to receive data");
		while (true)  {
			this.fromClient = inFromClient.readLine();
			if (this.fromClient != null) {
					System.out.println("From client" + this.fromClient);
					return this.fromClient;
					}
		}
	}
	
	public void sendData(String data){
		System.out.println("Sending data: " + data);
		outToClient.println(data);
	}
	
	
	public static void main(String argv[]) throws Exception {
		TCPServer server = new TCPServer(5000);
		String plan;
		//Simulating the communication cycle when connecting both systems
		while(true) {
			//Receives case description
			server.receiveData();
			//Sends solution (controlplan)
			plan = "";
			for (int j = 0; j<2;j++) {
				for (int i = 0; i<4;i++) {
					if (i % 2 == 0)
						plan = plan.concat(Integer.toString((int) (Math.random()*100)));
					else plan = plan.concat(Integer.toString(2));
					if (i != 3)
						plan = plan.concat(",");
					else if (j == 0) plan = plan.concat("-");
				}
			}
			//System.out.println("plan " + plan);
			server.sendData(plan);
			//server.sendData("5,2,5,2-5,1,40,1-4,1,20,1-10,1,4,1");
			//server.sendData("5,2,5,2-10,1,4,1");
			//Receives outcome
			server.receiveData();
			
		}
		
	}
}
        
