import sys
import time
sys.path.append("ole/")
from PyANGBasic import *
from PyANGKernel import *
from PyANGGui import *

import simulator_manager as SM

def main(argv):
    start = time.clock()
    if len(argv) < 4:
        print "Usage: aimsun.exe -script %s ANG_FILE " % argv[2]
        return -1
    # Get the GUI
    gui = GKGUISystem.getGUISystem().getActiveGui()
    # Load a network
    if gui.loadNetwork(argv[3]):
        # Here you can do things with the model
        sm = SM.SimulatorManager(gui)
        sm.run_simulation_cycles()
    else:
        gui.showMessage( GGui.eCritical, "Open error", "Cannot load the network" )
    elapsed = (time.clock()-start)
    print "Elapsed time: %f, Number of simulations: %i, Average simulation time: %f" % (elapsed, sm.number_of_simulation_cycles, elapsed/sm.number_of_simulation_cycles)

main(sys.argv)
