class ControlPlan(object):
    def __init__(self):
        self.phases = []
        self.control_junction = None

    def set_phases(self):
        total_time = 0.0
        p = self.control_junction.getPhases()
        for i in xrange(len(p)):
            p[i].setFrom(total_time)
            try:
                p[i].setDuration(self.phases[i])
            except:
                print "Different phase length in aimsun signal plan vs signal plan object, setting lenght as 0"
                p[i].setDuration(0)

            total_time += p[i].getDuration()
            print "Phase id: %i Duration %i seconds" % \
                (p[i].getId(),p[i].getDuration())
            self.control_junction.setCycle(total_time)

# class MasterControlPlan(object):
#     def __init__(self):
#         self.control_plans = []
    
class ControlPlanFactory:
    @staticmethod
    def get_signal_plans_used_in_model(model):
        controlPlan = model.getType( "GKControlPlan" )
        for types in model.getCatalog().getUsedSubTypesFromType( controlPlan ):
            for s in types.itervalues():
                print "Control Plan ID: %i" % (s.getId())
                for controlJunctionID in s.getControlJunctions():
                    print "controljunctionID", controlJunctionID
                    signal_plan = ControlPlan(model)
                    signal_plan.control_junction = s.getControlJunction(controlJunctionID)
                    for phase in signal_plan.control_junction.getPhases():
                        signal_plan.phases.append(phase.getDuration())
                    print "NY SIGNAL PLAN"
                    return signal_plan

    @staticmethod
    def get_dynamic_master_control_plan(model):
        return get_master_control_plan_by_name(model,"dynamic_mp")
    
    @staticmethod
    def get_static_master_control_plan(model):
        return get_master_control_plan_by_name(model,"static_mp")

    def get_master_control_plan_by_name(model,name):
        m = model.getType("GKMasterControlPlans")
        for types in model.getCatalog().getUsedSubTypesFromType(m):
            for mcp in types.itervalues():
                print "MCP.getName ", mcp.getName
                if (mcp.getName == name):
                    return mcp
        print "Did not find a MasterControlPlan with the name: ", name
        return None
